import type { WriteOptions } from 'atomically/dist/types';
import type { Disposer, Encoding, ProviderFileOptions } from '../types';
import ProviderMemory from './memory';
declare abstract class ProviderAbstractFile<Options extends ProviderFileOptions = ProviderFileOptions> extends ProviderMemory<Options> {
    path?: string;
    watching: boolean;
    watcherDisposer?: Disposer;
    writeOptions?: WriteOptions;
    writeSyncOptions?: WriteOptions;
    constructor(options: Options);
    dispose(): void;
    swap(path?: string, _initial?: boolean): void;
    watch(): void;
    unwatch(): void;
    abstract fileRead(filePath: string, encoding: Encoding): Promise<string>;
    abstract fileReadSync(filePath: string, encoding: Encoding): string;
    abstract fileWrite(filePath: string, data: string, options?: WriteOptions): Promise<void>;
    abstract fileWriteSync(filePath: string, data: string, options?: WriteOptions): void;
    abstract fileWatch(filePath: string, callback: Function): Disposer;
}
export default ProviderAbstractFile;
