/* IMPORT */
import ProviderMemory from './memory.js';
/* MAIN */
class ProviderAbstractFile extends ProviderMemory {
    /* CONSTRUCTOR */
    constructor(options) {
        super(options);
        this.watching = options.watch ?? false;
        this.writeOptions = options.writeOptions;
        this.writeSyncOptions = options.writeSyncOptions;
        this.swap(options.path, true);
    }
    /* PUBLIC API */
    dispose() {
        super.dispose();
        this.unwatch();
    }
    swap(path, _initial = false) {
        if (path === this.path)
            return;
        this.dispose();
        this.path = path;
        this.init();
        if (!_initial)
            this.trigger();
        if (this.watching)
            this.watch();
    }
    watch() {
        if (!this.path)
            return;
        const path = this.path;
        this.watcherDisposer = this.fileWatch(path, async () => {
            const { dataRaw } = await this.read();
            if (path !== this.path)
                return;
            if (this.isEqual(dataRaw))
                return;
            super.writeSync(dataRaw, true);
        });
    }
    unwatch() {
        this.watcherDisposer?.();
        this.watcherDisposer = undefined;
    }
}
/* EXPORT */
export default ProviderAbstractFile;
