import type { WriteOptions } from 'atomically/dist/types';
import type { Callback, Disposer, Encoding, ProviderJSONOptions } from '../types';
import ProviderAbstractJSON from './abstract_json';
declare class ProviderJSON<Options extends ProviderJSONOptions = ProviderJSONOptions> extends ProviderAbstractJSON<Options> {
    fileRead(filePath: string, encoding: Encoding): Promise<string>;
    fileReadSync(filePath: string, encoding: Encoding): string;
    fileWrite(filePath: string, data: string, options?: WriteOptions): Promise<void>;
    fileWriteSync(filePath: string, data: string, options?: WriteOptions): void;
    fileWatch(filePath: string, callback: Callback): Disposer;
}
export default ProviderJSON;
