/* IMPORT */
import PathProp from '../utils/pp.js';
import ProviderMemory from './memory.js';
/* MAIN */
class ProviderStorage extends ProviderMemory {
    /* CONSTRUCTOR */
    constructor(options) {
        super(options);
        this.id = options?.id;
        this.storage = options.storage;
        this.init();
    }
    /* PUBLIC API */
    readSync() {
        const dataRaw = this.storage.getItem(this.id) ?? this.defaultsRaw;
        const data = PathProp.unflat(this.dataParser.parse(dataRaw) ?? this.defaults);
        return { data, dataRaw };
    }
    writeSync(data, force = false) {
        if (!force && this.isEqual(data))
            return;
        super.writeSync(data, true);
        try {
            this.storage.setItem(this.id, this.dataRaw);
        }
        catch { }
    }
}
/* EXPORT */
export default ProviderStorage;
